"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function Hooks() {
    return function (target) {
        ['ngOnInit', 'ngOnChanges', 'ngOnDestroy'].forEach(function (hook) {
            var original = target.prototype[hook];
            if (typeof original === 'function') {
                target.prototype[hook] = function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    console.log.apply(console, [target.constructor.name + " " + hook + "()"].concat(args));
                    original.call.apply(original, [this].concat(args));
                };
            }
        });
    };
}
exports.Hooks = Hooks;
